function hide(o) {
  L.DomUtil.addClass(o, 'hide');
}
function show(o) {
  L.DomUtil.removeClass(o, 'hide');
}

function setOpacity(o, opacity) {
  //opacity slower than you'd think on e9
  //so no smooth transition fade in-out
  L.DomUtil.setOpacity(o, opacity); 
}

L.Control.GPS = L.Control.extend( {
  isAlert: false,
  isDeltaIconShown: false,
  alert_opacity: 0,
  alert_div: null,
  control_bottom_div: null,
  control_top_div: null,
  image_div: null,
  tower_image: null,
  satellite_image: null,
  satellite_delta_image: null,
  accuracy_alert_div: null,

  setStatusInfo: function (distance, units) {
    this.accuracy_alert_div.innerHTML = '<div class="accuracy_text_div">' + distance + '<br />' + units + '</div>';
  },
  setIconPanelVisibility: function (visible) {
    if (visible) show(this.image_div);
    else hide(this.image_div);
  },
  setSatelliteIconVisibility: function (visible) {
    if (visible) show(this.satellite_image);
      else hide(this.satellite_image);
  },
  setTowerIconVisibility: function (visible) {
    if (visible) show(this.tower_image);
      else hide(this.tower_image);
  },
  setDeltaIconVisibility: function (visible) {
    if (visible) show(this.satellite_delta_image);
    else hide(this.satellite_delta_image);
  },
  setAccuracyAlert: function (isAlert) {
    if (isAlert)
	  {
		  this.accuracy_alert_div.setAttribute('style','background: #db4600');	
		  this.control_bottom_div.setAttribute('style','color: #FFFFFF');
	  }	
    else
	  {
		  this.accuracy_alert_div.setAttribute('style','background: #ffffff');
		  this.control_bottom_div.setAttribute('style','color: #282828');
	  }
  },
  setAlert: function (isAlert) {
    if (isAlert) show(this.alert_div);
      else hide(this.alert_div);
    this.isAlert = isAlert;
  },
	options: {
		position: 'topleft',
	},
	onAdd: function (map) {
	  var className = 'leaflet-control-gps',
			container = L.DomUtil.create('div', className);
	  this._panButton(container);
		return container;
	},
	_panButton: function (container) {
	  var wrapper = L.DomUtil.create('div', 'leaflet-bar leaflet-control-gps-wrap', container);	  
	  this.control_top_div = L.DomUtil.create('div', 'control_top_div', wrapper);

	  this.image_div = L.DomUtil.create('div', 'hide image_div', this.control_top_div);

	  this.satellite_image = L.DomUtil.create('img', 'hide satellite_icon', this.image_div);
	  this.satellite_image.setAttribute('src', 'GNSSLeafletControl/ic_satellite_dark.png');

	  this.satellite_delta_image = L.DomUtil.create('img', 'hide satellite_icon', this.image_div);
	  this.satellite_delta_image.setAttribute('src', 'GNSSLeafletControl/ic_satellite_real_dark.png');

	  this.tower_image = L.DomUtil.create('img', 'hide satellite_icon', this.image_div);
	  this.tower_image.setAttribute('src', 'GNSSLeafletControl/ic_tower_dark.png');

	  this.alert_div = L.DomUtil.create('div', 'hide alert-div', this.image_div);

	  L.DomUtil.create('div', 'control_line_div', wrapper);

	  this.control_bottom_div = L.DomUtil.create('div', 'control_bottom_div', wrapper);

	  this.accuracy_alert_div = L.DomUtil.create('div', 'accuracy-alert-div ', this.control_bottom_div);

	  this.accuracy_alert_div.innerHTML = '<div class="accuracy_text_div">---<br/>--</div>';

	  var _self = this;
		L.DomEvent
			.on(wrapper, 'click', L.DomEvent.stopPropagation)
			.on(wrapper, 'click', L.DomEvent.preventDefault)
			.on(wrapper, 'click', function (e) {
			  SyncCallback('callback://gnssStatusClick/');
			})
			.on(wrapper, 'dblclick', L.DomEvent.stopPropagation)
	}
});

L.Map.mergeOptions({
    gpsControl: true
});

L.Map.addInitHook(function () {
  if (this.options.gpsControl) {
    this.gpsControl = new L.Control.GPS();
    this.addControl(this.gpsControl);
	}
});

L.control.gps = function (options) {
  return new L.Control.GPS(options);
};


