var PointLayer = L.LayerGroup.extend({
  initialize: function (name, zOrder, color) {
    this._layers = {};
    this.name = name;
    this.template = {
      'zOrder': zOrder,
      'color': color,
      'opacity': 1.0,
      'fillOpacity': 1.0
    };
  },

  bringToFront: function () {
    return this.invoke('bringToFront');
  },

  bringToBack: function () {
    return this.invoke('bringToBack');
  }
});
var LineLayer = L.LayerGroup.extend({

  initialize: function (name, zOrder, strokeColor, strokeWeight) {
    this._layers = {};
    this.name = name;
    this.template = {
      'zOrder': zOrder,
      'color': strokeColor,
      'weight': strokeWeight,
      'opacity': 1.0
    };
  },

  bringToFront: function () {
    return this.invoke('bringToFront');
  },

  bringToBack: function () {
    return this.invoke('bringToBack');
  }
});
var AreaLayer = L.LayerGroup.extend({
  initialize: function (name, zOrder, strokeColor, strokeWeight, fillColor) {
    this._layers = {};
    this.name = name;
    this.template = {
      'zOrder': zOrder,
      'color': strokeColor,
      'weight': strokeWeight,
      'opacity': 0.5, //line opacity
      'fillColor': fillColor,
      'fillOpacity': 0.2
    };
  },

  bringToFront: function () {
  return this.invoke('bringToFront');
  },

  bringToBack: function () {
    return this.invoke('bringToBack');
  }
});

function RezOrderLayers(layers) {
  for (var layer in layers) {
    if (layers[layer] instanceof LineLayer) {
      layers[layer].bringToFront();
    }
  }

  for (var layer in layers) {
    if (layers[layer] instanceof PointLayer)
      layers[layer].bringToFront();
  }
  //AreaLayers would be left at back
}