function new_cursorlayer() {
  return {
    layer: null,
    shadow: null,
    angle: 0,
    g_angle: 0,
    _shadowOffset: { x: 0, y: 0 },
    hide: function (rate) {
      if (!rate) rate = 200;
      this.layer.stop();
      this.shadow.stop();
      this.layer.attr({}).animate({ opacity: 0.0 }, rate);
      this.shadow.attr({}).animate({ opacity: 0.0 }, rate);
    },
    show: function (rate) {
      if (!rate) rate = 200;
      this.layer.stop();
      this.shadow.stop();
      this.layer.attr({}).animate({ opacity: 1.0 }, rate);
      this.shadow.attr({}).animate({ opacity: 0.3 }, rate);
    },
    clear: function () { if (this.layer) this.layer.remove(); if (this.shadow) this.shadow.remove(); },
    transform: function (map, target_angle, latlng, animate) {
      var rate = 250;
     // this._latlng = latlng;
      this._p = map.latLngToLayerPoint(latlng);
      var dx = this._p.x;
      var dy = this._p.y;

      if (target_angle) {
        a = target_angle - this.angle
        a = (a + 180) % 360 - 180
        b = 360 - Math.abs(a);
        this.g_angle += Math.abs(a) < Math.abs(b) ? a : b;
        this.angle = target_angle;
      }

      var tranformShadow = "R" + this.g_angle + ",0,0" + "T" + [dx + this._shadowOffset.x, dy + this._shadowOffset.y];
      var tranformTop = "R" + this.g_angle + ",0,0" + "T" + [dx, dy];

      if (animate) {
        var anim = Raphael.animation({ transform: tranformShadow }, rate, ">");
        var elem = this.shadow.animate(anim);
        this.layer.animateWith(elem, anim, { transform: tranformTop }, rate, ">");
      }
      else {
        this.shadow.transform(tranformShadow);
        this.layer.transform(tranformTop);
      }
    }
  }
};

R.PositionDirectionCursor = R.Layer.extend({
  initialize: function (latlng) {
    R.Layer.prototype.initialize.call(this, null);
    this._shadowOffset = { x: 3, y: 2 };
    this._latlng = latlng;
    this._isDirectionalCursor = true;
    this._userPointer = new_cursorlayer();
    this._featurePointer = null;//new_cursorlayer();
    this._visible_featurePointer = false;
  },
  toggle_visibility: function()
  {
    this._featurePointer.hide();
    this._visible_featurePointer = !this._visible_featurePointer;
  },
  set_userdirection: function (target_angle, animate)
  {
    this.userDirectionPosition(target_angle, this._latlng, animate);
  },
  get_LatLng: function () {
    return this._latlng;
  },
  userDirectionPosition: function (target_angle, latlng, animate) {
    this._latlng = latlng;

    //change cursors if needed
    if ((target_angle != null) && !this._isDirectionalCursor) {
      this.createDirectionalCursor();
    } else if ((target_angle == null) && this._isDirectionalCursor) {
      this.createNoDirectionalCursor();
    }
    this._userPointer.transform(this._map, target_angle, latlng, animate);

    if(this._featurePointer)
      this._featurePointer.transform(this._map, this._featurePointer.angle, latlng, animate); //position of feature pointer to match visible or not
  },
  featureDirection: function (target_angle, color, animate) {
    this._featurePointer.layer.stop();
    this._featurePointer.shadow.stop();

    if (this._visible_featurePointer) {
      this._featurePointer.layer.attr({}).animate({ fill: color, stroke: color, opacity: 1.0 }, 200);
      this._featurePointer.shadow.attr({}).animate({ opacity: 0.3 }, 200);
    }
    this._featurePointer.transform(this._map, target_angle, this._latlng, animate);

  },
  createFeatureCursor: function () {
    this._featurePointer.clear();

    var data = 'M3.976-5.448L0-17.375L-3.976-5.448C-5.655-4.22-6.75-2.241-6.75,0c0,3.73,3.02,6.75,6.75,6.75S6.75,3.73,6.75,0C6.75-2.241,5.655-4.22,3.976-5.448z';
    this._featurePointer.shadow = this._paper.path(data);
    this._featurePointer.shadow.attr({ 'stroke-width': 5.0, 'stroke': '#000000', 'opacity': 0.0, 'fill': '#000000' });
    this._featurePointer.shadow.toBack();

    this._featurePointer.layer = this._paper.set();
    var path = this._paper.path(data);
    path.attr({ 'stroke-width': 2.0, 'stroke': '#ffd200', 'fill': '#ffffff' });
    this._featurePointer.layer.push(path);
    this._featurePointer.layer.attr({'opacity': 0.0});


    this._featurePointer.transform(this._map, this._featurePointer.angle, this._latlng, false);
    this._featurePointer.hide();
  },

  createDirectionalCursor: function () {
    this._isDirectionalCursor = true;
    this._userPointer.clear();

    var data = 'M3.976-5.448L0-17.375L-3.976-5.448C-5.655-4.22-6.75-2.241-6.75,0c0,3.73,3.02,6.75,6.75,6.75S6.75,3.73,6.75,0C6.75-2.241,5.655-4.22,3.976-5.448z';
    this._userPointer.shadow = this._paper.path(data);
    this._userPointer.shadow.attr({  'stroke-width': 3.0, 'stroke': '#000000', 'opacity': 0.3, 'fill': '#000000' });
    
    this._userPointer.layer = this._paper.set();
    var path = this._paper.path(data);
    path.attr({ 'stroke-width': 0.0, 'fill': '#FFFFFF' });
    
    this._userPointer.layer.push(path);

    var data = 'M2.291-3.856L0-10.734l-2.292,6.881C-3.607-3.069-4.5-1.647-4.5,0c0,2.48,2.02,4.5,4.5,4.5c2.49,0,4.5-2.02,4.5-4.5C4.5-1.649,3.609-3.073,2.291-3.856z';
    path = this._paper.path(data);
    path.attr({ 'stroke': "none", 'fill': '#000000' }); //008CC8
    this._userPointer.layer.push(path);
    

    this._userPointer.transform(this._map, this._userPointer.angle, this._latlng, false);

    this._userPointer.shadow.attr({ 'opacity': 0.0 });
    this._userPointer.layer.attr({ 'opacity': 0.0 });
    this._userPointer.show();

  },
  createNoDirectionalCursor: function () {
    this._isDirectionalCursor = false;
    this._userPointer.clear();
    this._userPointer.shadow = this._paper.circle(0, 0, 6.75);
    this._userPointer.shadow.attr({ 'stroke-width': 3.0, 'stroke': '#000000', 'opacity': 0.3, 'fill': '#000000' });

    this._userPointer.layer = this._paper.set();
    var path = this._paper.circle(0, 0, 6.75);
    path.attr({ 'stroke-width': 0, 'fill': '#FFFFFF' });
    this._userPointer.layer.push(path);

    var data = 'M0-4.5c-2.48,0-4.5,2.01-4.5,4.5c0,2.48,2.02,4.5,4.5,4.5c2.49,0,4.5-2.02,4.5-4.5C4.5-2.49,2.49-4.5,0-4.5z';
    var path = this._paper.path(data);
    path.attr({ 'stroke': "none", 'fill': '#000000' });
    this._userPointer.layer.push(path);
   
    this._userPointer.transform(this._map, this._userPointer.angle, this._latlng, false);
  },

  projectLatLngs: function () {

    //need to create a refresh on zoom.
    //this.createFeatureCursor(); //this is for showing the on map feature direction
    if (this._isDirectionalCursor)
      this.createDirectionalCursor();
    else this.createNoDirectionalCursor();
   
  }
});